// GPIOTE driver for nRF52840 | gat 11/04/23
#ifndef _GPIOTE_H_
#define _GPIOTE_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef enum
{
	GPIOTE_Event=1, // IN[n] event will be generated if operation specified in POLARITY occurs on the pin.
	GPIOTE_Task=3
}GPIOTE_Mode;

typedef enum
{
	GPIOTE_LowToHigh = 1,
	GPIOTE_HighToLow = 2,
	GPIOTE_Toggle = 3
}GPIOTE_Polarity;

typedef enum
{
	GPIOTE_Ch0,GPIOTE_Ch1,GPIOTE_Ch2,GPIOTE_Ch3,GPIOTE_Ch4,GPIOTE_Ch5,GPIOTE_Ch6,GPIOTE_Ch7
}GPIOTE_Channel;

typedef struct
{
	GPIOTE_Mode Mode;
	GPIOTE_Polarity Polarity;
	GPIOTE_Channel Channel;
	unsigned int Pin;
	unsigned int Port;
	void (*Event_Callback)(void);
}GPIOTE_Config;

void GPIOTE_Setup(GPIOTE_Config cfg);

void GPIOTE_Setup_NO_IRQ(GPIOTE_Config cfg);

#ifdef __cplusplus
}
#endif

#endif //_GPIOTE_H_
