// RTC driver for nRF52840 | gat 11/04/23
#ifndef _RTC_H_
#define _RTC_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef enum
{
	RTC0,
	RTC1,
	RTC2
} RTC_Channel;

typedef enum
{
	RTC_ISR_Tick_Event = 1, // enable int for tick event
	RTC_ISR_Compare0 = (1<<16) // event compare 0
} RTC_ISR;

typedef enum
{
	RTC_32k768Hz = 0,
	RTC_381Hz023 = 85 //32.768kHz / 86 -> 381.023Hz -> 2.62ms
} RTC_Prescaler;

typedef struct
{
	RTC_Channel channel;
	RTC_Prescaler prescaler;
	RTC_ISR irq;
} RTC_Config;

void RTC_Setup(RTC_Config cfg, void (*p_Frame_Received_Function)(void));

void RTC_Clear(RTC_Channel chann);

void RTC_Start(RTC_Channel chann, unsigned int time_period);

#ifdef __cplusplus
}
#endif

#endif // _RTC_H_
