// Radio driver for nRF52840 | gat 11/04/23
#ifndef _RADIO_H_
#define _RADIO_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef enum 
{
	_2MBPS = 1, 
	_1MBPS = 0, 
	_250KBPS = 2
} Radio_BitRate;

typedef struct
{
	unsigned char Adresses[2];
	unsigned char Channel;
	Radio_BitRate BitRate;
	unsigned char FrameSize;
} Radio_Config;

void Radio_Init(Radio_Config Config, void* p_data_byte_aligned, void (*p_Frame_Received_Function)(void));

void Radio_Start(void);

void Radio_Stop(void);

unsigned int Radio_Get_CRC_Status(void);

#ifdef __cplusplus
}
#endif

#endif // _RADIO_H_
