// SPI Master driver for nRF52840 | gat 11/04/23
#ifndef _SPIM_H_
#define _SPIM_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef enum
{
	SPIM0,
	SPIM1,
	SPIM2,
	SPIM3
}SPIM_Channel;

typedef enum
{
	SPI_K125 = 0x02000000,
	SPI_K250 = 0x04000000,
	SPI_K500 = 0x08000000,
	SPI_M1 = 0x10000000,
	SPI_M2 = 0x20000000,
	SPI_M4 = 0x40000000,
	SPI_M8 = 0x80000000,
	SPI_M16 = 0x0A000000,
	SPI_M32 = 0x14000000
}SPIM_Freq;

typedef enum
{
	Leading=0,
	Trailing=1
}SPIM_CPHA;

typedef enum
{
	ActiveHigh=0,
	ActiveLow=1
}SPIM_CPOL;

typedef enum
{
	MSB_First=0,
	LSB_First=1
}SPIM_Endian;

typedef struct
{
	SPIM_Channel Channel;
	SPIM_Freq Freq;
	SPIM_CPHA CPHA;
	SPIM_CPOL CPOL;
	SPIM_Endian Endian;
	unsigned int MOSI_Pin;
	unsigned int MOSI_Port;
	unsigned int MISO_Pin;
	unsigned int MISO_Port;
	unsigned int CLK_Pin;
	unsigned int CLK_Port;
	unsigned int CS_Pin;
	unsigned int CS_Port;
}SPIM_Config;

void SPIM_Setup(SPIM_Config cfg);
void SPIM_Tx(SPIM_Channel ch, void* data, unsigned short length);
void SPIM0_IRQ(void);
void SPIM1_IRQ(void);

#ifdef __cplusplus
}
#endif

#endif //_SPIM_H_
