// TWI Master driver for nRF52840 | gat 11/04/23
#ifndef _TWIM_H_
#define _TWIM_H_

#include "FreeRTOS.h"
#include "task.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum
{
	TWI0,
	TWI1
}TWIM_Channel;

typedef enum
{
	K100 = 0x01980000UL,
	K250 = 0x04000000UL,
	K400 = 0x06400000UL
}TWIM_Freq;

typedef struct
{
	unsigned char Overrun;
	unsigned char AddressNACK;
	unsigned char DataNACK;
}TWIM_Status;

typedef struct
{
	TWIM_Channel Channel;
	TWIM_Freq Freq;
	unsigned int SDA_Pin;
	unsigned int SDA_Port;
	unsigned int SCL_Pin;
	unsigned int SCL_Port;
}TWIM_Config;


void TWIM_Setup(TWIM_Config cfg);
void TWIM_Rx(TWIM_Channel ch, unsigned char addr, unsigned short length, unsigned char* ptr, TaskHandle_t WakeMeUp);
void TWIM_Tx(TWIM_Channel ch, unsigned char addr, unsigned short length, unsigned char* ptr, TaskHandle_t WakeMeUp);
//void TWIM0_IRQ(void);
void TWIM1_IRQ(void);
void TWIM_GetStatus(TWIM_Channel ch);
TWIM_Status TWIM_ReadStatus(TWIM_Channel ch);

#ifdef __cplusplus
}
#endif

#endif //_TWIM_H_
