// UART driver for nRF52840 | gat 11/04/23
#ifndef _UART_H_
#define _UART_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef enum
{
	UARTE0,
	UARTE1
}UART_Channel;

typedef enum
{
	Baud115200=0x01D60000,
	Baud250000=0x04000000,
	Baud256000=0x04104000,
	Baud460800=0x07400000
}UART_Baud;

typedef struct
{
	UART_Channel Chann;
	UART_Baud Baud;
	unsigned int Rx_Pin;
	unsigned int Rx_Port;
	unsigned int Tx_Pin;
	unsigned int Tx_Port;
}UART_Config;

void UART_Setup(UART_Config cfg);

#ifdef __cplusplus
}
#endif

#endif //_UART_H_
