#include "FlashStorage.hpp"
#include "Flash.h"
#include <cstring>

void FlashStorage::Load_Daemon_Version(unsigned char* Version_MSB, unsigned char* Version_MidSB, unsigned char* Version_LSB)
{
	unsigned char local_data[3];
	Flash_Read((unsigned int)SegA, 3, local_data);
	*Version_MSB = local_data[0];
	*Version_MidSB = local_data[1];
	*Version_LSB = local_data[2];
}

#define SerialNumber_Size 8U

void FlashStorage::Store_Serial_Number(unsigned char* ptr)
{
	TypeB_Storage Bstorage;
	Flash_Read((unsigned int)SegB, sizeof(TypeB_Storage), (void*)Bstorage.SerialNumber);
	memcpy(Bstorage.SerialNumber, ptr, SerialNumber_Size);
	Flash_Write((unsigned int)SegB, sizeof(TypeB_Storage), (void*)Bstorage.SerialNumber);
}

void FlashStorage::Load_Serial_Number(unsigned char* ptr)
{
	TypeB_Storage Bstorage;
	Flash_Read((unsigned int)SegB, sizeof(TypeB_Storage), (void*)Bstorage.SerialNumber);
	memcpy(ptr, Bstorage.SerialNumber, SerialNumber_Size);
}
